#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
umask 022
export PATH='/bin:/usr/bin:/usr/local/bin'
export CFLAGS=${CFLAGS:--Os}
export CXXFLAGS=${CXXFLAGS:--Os}

rebuild () {
    tar xjf xf86-video-openchrome-0.2.904.tar.bz2
    cd xf86-video-openchrome-0.2.904
    bunzip2 -c ../xf86-video-openchrome-0.2.904-vt1625_PAL.patch.bz2 | patch \
	    -p1 -b
    ./configure --prefix=/usr --sysconfdir=/etc/X11 --localstatedir=/var \
	    --datarootdir=/usr/lib --disable-static \
	    --with-xorg-module-dir=/usr/lib/xorg/modules
    make
    strip -R .note -R .comment libxvmc/.libs/libchromeXvMC*.so.1 \
	    src/.libs/openchrome_drv.so
    mkdir -p ../xserver-xorg-accel-openchrome/lib/xorg/modules/drivers
    cp libxvmc/.libs/libchromeXvMC*.so.1  ../xserver-xorg-accel-openchrome/lib/
    cp src/.libs/openchrome_drv.so \
	    ../xserver-xorg-accel-openchrome/lib/xorg/modules/drivers
    cd ..
    rm -rf xf86-video-openchrome-0.2.904
}

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`
for CTRLFILE in */CONTROL/control; do
    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/..
done
